VERSION 5.00
Begin VB.UserControl CTDynFrame 
   AutoRedraw      =   -1  'True
   ClientHeight    =   2025
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   2235
   ControlContainer=   -1  'True
   BeginProperty Font 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ScaleHeight     =   135
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   149
   ToolboxBitmap   =   "CTDynFrame.ctx":0000
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   100
      Left            =   30
      Top             =   300
   End
   Begin VB.Label Helper 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "s"
      BeginProperty Font 
         Name            =   "Marlett"
         Size            =   8.25
         Charset         =   2
         Weight          =   500
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00C0C0C0&
      Height          =   165
      Left            =   1770
      TabIndex        =   3
      Top             =   45
      Width           =   165
   End
   Begin VB.Label Closer 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "r"
      BeginProperty Font 
         Name            =   "Marlett"
         Size            =   8.25
         Charset         =   2
         Weight          =   500
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00C0C0C0&
      Height          =   165
      Left            =   1980
      TabIndex        =   2
      Top             =   45
      Width           =   165
   End
   Begin VB.Label Arrow 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "4"
      BeginProperty Font 
         Name            =   "Marlett"
         Size            =   9.75
         Charset         =   2
         Weight          =   500
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00C0C0C0&
      Height          =   195
      Left            =   60
      TabIndex        =   1
      Top             =   30
      Width           =   195
   End
   Begin VB.Label CaptionLabel 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "CTDynFrame"
      ForeColor       =   &H00C0C0C0&
      Height          =   195
      Left            =   300
      TabIndex        =   0
      Top             =   30
      Width           =   1095
   End
   Begin VB.Shape Shape1 
      BackColor       =   &H00000000&
      BorderColor     =   &H00000000&
      BorderStyle     =   0  'Transparent
      FillColor       =   &H00808080&
      FillStyle       =   0  'Solid
      Height          =   270
      Left            =   0
      Shape           =   4  'Rounded Rectangle
      Top             =   0
      Width           =   2235
   End
End
Attribute VB_Name = "CTDynFrame"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 06/2008

Option Explicit

Dim isOpen As Boolean
Dim normHeight As Long

Dim isCloserMouseDown As Boolean
Dim isArrowMouseDown As Boolean
Dim isHelperMouseDown As Boolean
Dim isDblClick As Boolean

Private Const BDR_RAISEDOUTER = &H1
Private Const BDR_SUNKENOUTER = &H2
Private Const BDR_OUTER = &H3
Private Const BDR_RAISEDINNER = &H4
Private Const BDR_RAISED = &H5
Private Const BDR_SUNKENINNER = &H8
Private Const BDR_SUNKEN = &HA
Private Const BDR_INNER = &HC


Private Const BF_LEFT = &H1
Private Const BF_TOP = &H2
Private Const BF_RIGHT = &H4
Private Const BF_BOTTOM = &H8
Private Const BF_RECT = (BF_LEFT Or BF_TOP Or BF_RIGHT Or BF_BOTTOM)

Private Type POINTAPI
    X As Long
    Y As Long
End Type

Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Public Enum ShapeRect
    [Gerundetes Rechteck] = 0
    Rechteck = 1
End Enum

Public Enum FrameBodyRect
    [Border RAISEDOUTER] = BDR_RAISEDOUTER '1
    [Border SUNKENOUTER] = BDR_SUNKENOUTER '2
    [Border RAISEDINNER] = BDR_RAISEDINNER '4
    [Border RAISED] = BDR_RAISED '5
    [Border ETCHED] = BDR_SUNKENOUTER Or BDR_RAISEDINNER '6
    [Border SUNKENINNER] = BDR_SUNKENINNER '8
    [Border ETCHED2] = BDR_SUNKENINNER Or BDR_RAISEDOUTER '9
    [Border SUNKEN] = BDR_SUNKEN '10
End Enum

Public Enum FrameBodyLine
    [BorderLine None] = 0 '0
    [BorderLine Left] = BF_LEFT '1
    [BorderLine Top] = BF_TOP '2
    [BorderLine TopLeft] = BF_TOP Or BF_LEFT '3
    [BorderLine Right] = BF_RIGHT '4
    [BorderLine RightLeft] = BF_LEFT Or BF_RIGHT '5
    [BorderLine RightTop] = BF_TOP Or BF_RIGHT '6
    [BorderLine RightTopLeft] = BF_TOP Or BF_RIGHT Or BF_LEFT '7
    [BorderLine Bottom] = BF_BOTTOM '8
    [BorderLine BottomLeft] = BF_LEFT Or BF_BOTTOM '9
    [BorderLine BottomTop] = BF_TOP Or BF_BOTTOM '10
    [BorderLine BottomTopLeft] = BF_TOP Or BF_BOTTOM Or BF_LEFT '11
    [BorderLine BottomRight] = BF_RIGHT Or BF_BOTTOM '12
    [BorderLine BottomRightLeft] = BF_RIGHT Or BF_BOTTOM Or BF_LEFT '13
    [BorderLine BottomRightTop] = BF_RIGHT Or BF_BOTTOM Or BF_TOP '14
    [BorderLine Rect] = BF_RECT '15
End Enum

Private Declare Function GetCursorPos Lib "user32" ( _
                         lpPoint As POINTAPI) As Long

Private Declare Function GetWindowRect Lib "user32" ( _
                         ByVal hwnd As Long, _
                         lpRect As RECT) As Long

Private Declare Function DrawEdge Lib "user32" ( _
                         ByVal hdc As Long, _
                         qrc As RECT, _
                         ByVal edge As Long, _
                         ByVal grfFlags As Long) As Long

'Standard Eigenschaftswerte:
Const m_def_InnerLineOffset = 0
Const m_def_OuterLineOffset = 0
Const m_def_OuterFrameBodyLineStyle = BF_RECT
Const m_def_OuterFrameBodyStyle = BDR_SUNKENOUTER Or BDR_RAISEDINNER
Const m_def_InnerFrameBodyLineStyle = 0
Const m_def_InnerFrameBodyStyle = BDR_SUNKENOUTER Or BDR_RAISEDINNER
Const m_def_CaptionBarStyle = 0
Const m_def_CaptionInActiveColor = &HC0C0C0
Const m_def_CaptionActiveColor = &HFFFFFF
Const m_def_CaptionMouseDownColor = &HFFFF&
Const m_def_ShowClose = True
Const m_def_ShowHelp = False

'Eigenschaft-Variablen:
Dim m_InnerLineOffset As Long
Dim m_OuterLineOffset As Long
Dim m_OuterFrameBodyLineStyle As FrameBodyLine
Dim m_OuterFrameBodyStyle As FrameBodyRect
Dim m_InnerFrameBodyLineStyle As FrameBodyLine
Dim m_InnerFrameBodyStyle As FrameBodyRect
Dim m_CaptionBarStyle As ShapeRect
Dim m_CaptionActiveColor As OLE_COLOR
Dim m_CaptionInActiveColor As OLE_COLOR
Dim m_CaptionMouseDownColor As OLE_COLOR
Dim m_ShowClose As Boolean
Dim m_ShowHelp As Boolean

'Ereignisdeklarationen:
Event CloseButton()
Event HelpButton()
Event Changed()

Private Sub ChangeWidth()

    Dim oldWidth As Long
    Dim newWidth As Long

    oldWidth = CaptionLabel.Left + CaptionLabel.Width + 5

    If m_ShowClose = True Then oldWidth = oldWidth + 5 + Closer.Width
    If m_ShowHelp = True Then oldWidth = oldWidth + 5 + Helper.Width

    oldWidth = UserControl.ScaleX(oldWidth, vbPixels, vbTwips)
    newWidth = oldWidth + UserControl.ScaleX(10, vbPixels, vbTwips)

    If UserControl.Width < oldWidth Then UserControl.Width = newWidth

End Sub

Private Sub FrameSize()

    If isOpen = True Then

        isOpen = False
        Arrow.Caption = "6"
        UserControl.Height = UserControl.ScaleY(Shape1.Height, vbPixels, vbTwips)

    Else

        isOpen = True
        Arrow.Caption = "4"
        UserControl.Height = normHeight

    End If

End Sub

Private Sub SetForeColor()

    Arrow.ForeColor = m_CaptionInActiveColor
    CaptionLabel.ForeColor = m_CaptionInActiveColor
    Helper.ForeColor = m_CaptionInActiveColor
    Closer.ForeColor = m_CaptionInActiveColor

End Sub

Private Sub DrawNew()

    Dim ThCaption As Long

    ChangeWidth

    Arrow.FontName = "Marlett"
    Closer.FontName = "Marlett"
    Helper.FontName = "Marlett"
    Arrow.FontSize = UserControl.FontSize + 2
    Closer.FontSize = UserControl.FontSize
    Helper.FontSize = UserControl.FontSize

    ThCaption = UserControl.TextHeight(CaptionLabel.Caption)

    If m_CaptionBarStyle = Rechteck Then

        Shape1.Shape = 0

    Else

        Shape1.Shape = 4

    End If

    Shape1.Height = ThCaption + 3
    Shape1.Width = UserControl.ScaleWidth

    UserControl.Cls

    If isOpen = True Then

        If m_OuterFrameBodyLineStyle <> [BorderLine None] Then

            Dim OuterEdgeRect As RECT

            OuterEdgeRect.Top = Shape1.Height + m_OuterLineOffset
            OuterEdgeRect.Left = 0 + m_OuterLineOffset
            OuterEdgeRect.Right = UserControl.ScaleWidth - m_OuterLineOffset
            OuterEdgeRect.Bottom = UserControl.ScaleHeight - m_OuterLineOffset

            DrawEdge UserControl.hdc, OuterEdgeRect, m_OuterFrameBodyStyle, _
                m_OuterFrameBodyLineStyle

        End If

        If m_InnerLineOffset <> m_OuterLineOffset Then
            If m_InnerFrameBodyLineStyle <> [BorderLine None] Then

                Dim InnerEdgeRect As RECT

                InnerEdgeRect.Top = Shape1.Height + m_InnerLineOffset
                InnerEdgeRect.Left = 0 + m_InnerLineOffset
                InnerEdgeRect.Right = UserControl.ScaleWidth - m_InnerLineOffset
                InnerEdgeRect.Bottom = UserControl.ScaleHeight - m_InnerLineOffset

                DrawEdge UserControl.hdc, InnerEdgeRect, m_InnerFrameBodyStyle, _
                    m_InnerFrameBodyLineStyle

            End If
        End If

        Arrow.Move 5, ((Shape1.Height \ 2) - (Arrow.Height \ 2))

    Else

        Arrow.Move 5, ((Shape1.Height \ 2) - (Arrow.Height \ 2)) - 1

    End If

    Closer.Move Shape1.Width - Closer.Width - 5, ((Shape1.Height \ 2) - ( _
        Closer.Height \ 2)) - 1

    If Closer.Visible = True Then

        Helper.Move Closer.Left - Helper.Width - 5, ((Shape1.Height \ 2) - ( _
            Closer.Height \ 2)) - 1

    Else

        Helper.Move Shape1.Width - Helper.Width - 5, ((Shape1.Height \ 2) - ( _
            Helper.Height \ 2)) - 1

    End If

    CaptionLabel.Move Arrow.Left + Arrow.Width + 5, ((Shape1.Height \ 2) - ( _
        ThCaption \ 2)) - 1

End Sub

Private Sub Arrow_Click()

    FrameSize
    RaiseEvent Changed

End Sub

Private Sub Arrow_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As _
    Single)

    isArrowMouseDown = True

End Sub

Private Sub Arrow_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As _
    Single)

    isArrowMouseDown = False

End Sub

Private Sub CaptionLabel_DblClick()

    isDblClick = True

End Sub

Private Sub Closer_Click()

    RaiseEvent CloseButton

End Sub

Private Sub Closer_MouseDown(Button As Integer, Shift As Integer, X As Single, Y _
    As Single)

    isCloserMouseDown = True

End Sub

Private Sub Closer_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As _
    Single)

    isCloserMouseDown = False

End Sub

Private Sub Helper_Click()

    RaiseEvent HelpButton

End Sub

Private Sub Helper_MouseDown(Button As Integer, Shift As Integer, X As Single, Y _
    As Single)

    isHelperMouseDown = True

End Sub

Private Sub Helper_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As _
    Single)

    isHelperMouseDown = False

End Sub

Private Sub Timer1_Timer()

    Dim CtrlRect As RECT
    Dim CurPos As POINTAPI

    Call GetCursorPos(CurPos)
    Call GetWindowRect(UserControl.hwnd, CtrlRect)

    If CurPos.X < CtrlRect.Left Or CurPos.X > CtrlRect.Right Or CurPos.Y < _
        CtrlRect.Top Or CurPos.Y > CtrlRect.Top + Shape1.Height Then

        If isArrowMouseDown = True Or isCloserMouseDown = True Or _
            isHelperMouseDown = True Then

            If CaptionLabel.ForeColor <> m_CaptionActiveColor Then _
                CaptionLabel.ForeColor = m_CaptionActiveColor

        Else

            If CaptionLabel.ForeColor <> m_CaptionInActiveColor Then _
                CaptionLabel.ForeColor = m_CaptionInActiveColor

        End If

        If isArrowMouseDown = True And Arrow.ForeColor <> m_CaptionActiveColor _
            Then Arrow.ForeColor = m_CaptionActiveColor

        If isArrowMouseDown = False And Arrow.ForeColor <> m_CaptionInActiveColor _
            Then Arrow.ForeColor = m_CaptionInActiveColor

        If isCloserMouseDown = True And Closer.ForeColor <> m_CaptionActiveColor _
            Then Closer.ForeColor = m_CaptionActiveColor

        If isCloserMouseDown = False And Closer.ForeColor <> _
            m_CaptionInActiveColor Then Closer.ForeColor = m_CaptionInActiveColor

        If isHelperMouseDown = True And Helper.ForeColor <> m_CaptionActiveColor _
            Then Helper.ForeColor = m_CaptionActiveColor

        If isHelperMouseDown = False And Helper.ForeColor <> _
            m_CaptionInActiveColor Then Helper.ForeColor = m_CaptionInActiveColor

    Else

        If CurPos.X > CtrlRect.Left + Arrow.Left And CurPos.X < CtrlRect.Left + _
            Arrow.Left + Arrow.Width Then

            If isArrowMouseDown = False And Arrow.ForeColor <> _
                m_CaptionActiveColor Then Arrow.ForeColor = m_CaptionActiveColor

            If isArrowMouseDown = True And Arrow.ForeColor <> _
                m_CaptionMouseDownColor Then Arrow.ForeColor = _
                m_CaptionMouseDownColor

        Else

            If isArrowMouseDown = True And Arrow.ForeColor <> m_CaptionActiveColor _
                Then Arrow.ForeColor = m_CaptionActiveColor

            If isArrowMouseDown = False And Arrow.ForeColor <> _
                m_CaptionInActiveColor Then Arrow.ForeColor = _
                m_CaptionInActiveColor

        End If

        If CurPos.X > CtrlRect.Left + Closer.Left And CurPos.X < CtrlRect.Left + _
            Closer.Left + Closer.Width Then

            If isCloserMouseDown = False And Closer.ForeColor <> _
                m_CaptionActiveColor Then Closer.ForeColor = m_CaptionActiveColor

            If isCloserMouseDown = True And Closer.ForeColor <> _
                m_CaptionMouseDownColor Then Closer.ForeColor = _
                m_CaptionMouseDownColor

        Else

            If isCloserMouseDown = True And Closer.ForeColor <> _
                m_CaptionActiveColor Then Closer.ForeColor = m_CaptionActiveColor

            If isCloserMouseDown = False And Closer.ForeColor <> _
                m_CaptionInActiveColor Then Closer.ForeColor = _
                m_CaptionInActiveColor

        End If

        If CurPos.X > CtrlRect.Left + Helper.Left And CurPos.X < CtrlRect.Left + _
            Helper.Left + Helper.Width Then

            If isHelperMouseDown = False And Helper.ForeColor <> _
                m_CaptionActiveColor Then Helper.ForeColor = m_CaptionActiveColor

            If isHelperMouseDown = True And Helper.ForeColor <> _
                m_CaptionMouseDownColor Then Helper.ForeColor = _
                m_CaptionMouseDownColor

        Else

            If isHelperMouseDown = True And Helper.ForeColor <> _
                m_CaptionActiveColor Then Helper.ForeColor = m_CaptionActiveColor

            If isHelperMouseDown = False And Helper.ForeColor <> _
                m_CaptionInActiveColor Then Helper.ForeColor = _
                m_CaptionInActiveColor

        End If

        If CaptionLabel.ForeColor <> m_CaptionActiveColor Then _
            CaptionLabel.ForeColor = m_CaptionActiveColor

        If isDblClick = True Then

            isDblClick = False
            Arrow_Click

        End If
    End If

End Sub

Private Sub UserControl_DblClick()

    isDblClick = True

End Sub

Private Sub UserControl_Initialize()

    normHeight = UserControl.Height
    isOpen = True
    isArrowMouseDown = False
    isCloserMouseDown = False
    isHelperMouseDown = False
    isDblClick = False

End Sub

Private Sub UserControl_Resize()

    If UserControl.Height > UserControl.ScaleY(Shape1.Height, vbPixels, vbTwips) _
        Then normHeight = UserControl.Height

    DrawNew

End Sub

Private Sub UserControl_Show()

    SetForeColor
    Closer.Visible = m_ShowClose
    Helper.Visible = m_ShowHelp

    If FrameOpen = True Then

        Arrow.Caption = "4"

    Else

        Arrow.Caption = "6"

    End If

    DrawNew
    Timer1.Enabled = UserControl.Ambient.UserMode

End Sub

' ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
' MappingInfo=UserControl,UserControl,-1,BackColor
Public Property Get BackColor() As OLE_COLOR

    BackColor = UserControl.BackColor

End Property

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)

    UserControl.BackColor() = New_BackColor
    PropertyChanged "BackColor"

End Property

' ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
' MappingInfo=UserControl,UserControl,-1,Font
Public Property Get Font() As Font

    Set Font = UserControl.Font

End Property

Public Property Set Font(ByVal New_Font As Font)

    Set UserControl.Font = New_Font
    Set CaptionLabel.Font = New_Font

    DrawNew
    PropertyChanged "Font"

End Property

' ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
' MappingInfo=CaptionLabel,CaptionLabel,-1,Caption
Public Property Get Caption() As String

    Caption = CaptionLabel.Caption

End Property

Public Property Let Caption(ByVal New_Caption As String)

    CaptionLabel.Caption() = New_Caption
    ChangeWidth
    PropertyChanged "Caption"

End Property

' ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
' MappingInfo=Shape1,Shape1,-1,FillColor
Public Property Get CaptionBarColor() As OLE_COLOR

    CaptionBarColor = Shape1.FillColor

End Property

Public Property Let CaptionBarColor(ByVal New_CaptionBarColor As OLE_COLOR)

    Shape1.FillColor() = New_CaptionBarColor
    PropertyChanged "CaptionBarColor"

End Property

Public Property Get CaptionActiveColor() As OLE_COLOR

    CaptionActiveColor = m_CaptionActiveColor

End Property

Public Property Let CaptionActiveColor(ByVal New_CaptionActiveColor As OLE_COLOR)

    m_CaptionActiveColor = New_CaptionActiveColor
    PropertyChanged "CaptionActiveColor"

End Property

Public Property Get CaptionInActiveColor() As OLE_COLOR

    CaptionInActiveColor = m_CaptionInActiveColor

End Property

Public Property Let CaptionInActiveColor(ByVal New_CaptionInActiveColor As _
    OLE_COLOR)

    m_CaptionInActiveColor = New_CaptionInActiveColor
    PropertyChanged "CaptionInActiveColor"
    SetForeColor

End Property

Public Property Get CaptionMouseDownColor() As OLE_COLOR

    CaptionMouseDownColor = m_CaptionMouseDownColor

End Property

Public Property Let CaptionMouseDownColor(ByVal New_CaptionMouseDownColor As _
    OLE_COLOR)

    m_CaptionMouseDownColor = New_CaptionMouseDownColor
    PropertyChanged "CaptionMouseDownColor"

End Property

Public Property Get ShowClose() As Boolean

    ShowClose = m_ShowClose

End Property

Public Property Let ShowClose(ByVal New_ShowClose As Boolean)

    m_ShowClose = New_ShowClose
    Closer.Visible = m_ShowClose
    DrawNew
    PropertyChanged "ShowClose"

End Property

Public Property Get ShowHelp() As Boolean

    ShowHelp = m_ShowHelp

End Property

Public Property Let ShowHelp(ByVal New_ShowHelp As Boolean)

    m_ShowHelp = New_ShowHelp
    Helper.Visible = m_ShowHelp
    DrawNew
    PropertyChanged "ShowHelp"

End Property

Public Property Get FrameOpen() As Boolean

    FrameOpen = isOpen

End Property

Public Property Let FrameOpen(ByVal New_FrameOpen As Boolean)

    isOpen = Not New_FrameOpen
    FrameSize
    PropertyChanged "FrameOpen"

End Property

Public Property Get CaptionBarStyle() As ShapeRect

    CaptionBarStyle = m_CaptionBarStyle

End Property

Public Property Let CaptionBarStyle(ByVal New_CaptionBarStyle As ShapeRect)

    m_CaptionBarStyle = New_CaptionBarStyle
    DrawNew
    PropertyChanged "CaptionBarStyle"

End Property

' Eigenschaften fr Benutzersteuerelement initialisieren
Private Sub UserControl_InitProperties()

    Set Font = Ambient.Font

    m_CaptionActiveColor = m_def_CaptionActiveColor
    m_CaptionInActiveColor = m_def_CaptionInActiveColor
    m_CaptionMouseDownColor = m_def_CaptionMouseDownColor
    m_ShowClose = m_def_ShowClose
    m_ShowHelp = m_def_ShowHelp
    CaptionLabel.Caption = UserControl.Ambient.DisplayName
    m_CaptionBarStyle = m_def_CaptionBarStyle
    m_OuterFrameBodyStyle = m_def_OuterFrameBodyStyle
    m_OuterFrameBodyLineStyle = m_def_OuterFrameBodyLineStyle
    m_InnerFrameBodyStyle = m_def_InnerFrameBodyStyle
    m_InnerFrameBodyLineStyle = m_def_InnerFrameBodyLineStyle
    m_InnerLineOffset = m_def_InnerLineOffset
    m_OuterLineOffset = m_def_OuterLineOffset

End Sub

' Eigenschaftenwerte vom Speicher laden
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

    UserControl.BackColor = PropBag.ReadProperty("BackColor", &H8000000F)

    Set Font = PropBag.ReadProperty("Font", Ambient.Font)

    CaptionLabel.Caption = PropBag.ReadProperty("Caption", "CTDynFrame")
    Shape1.FillColor = PropBag.ReadProperty("CaptionBarColor", &H808080)

    m_CaptionActiveColor = PropBag.ReadProperty("CaptionActiveColor", _
        m_def_CaptionActiveColor)

    m_CaptionInActiveColor = PropBag.ReadProperty("CaptionInActiveColor", _
        m_def_CaptionInActiveColor)

    m_CaptionMouseDownColor = PropBag.ReadProperty("CaptionMouseDownColor", _
        m_def_CaptionMouseDownColor)

    m_ShowClose = PropBag.ReadProperty("ShowClose", m_def_ShowClose)
    m_ShowHelp = PropBag.ReadProperty("ShowHelp", m_def_ShowHelp)
    isOpen = PropBag.ReadProperty("FrameOpen", True)
    normHeight = PropBag.ReadProperty("NormalHeight", UserControl.Height)

    m_CaptionBarStyle = PropBag.ReadProperty("CaptionBarStyle", _
        m_def_CaptionBarStyle)

    m_OuterFrameBodyStyle = PropBag.ReadProperty("OuterFrameBodyStyle", _
        m_def_OuterFrameBodyStyle)

    m_OuterFrameBodyLineStyle = PropBag.ReadProperty("OuterFrameBodyLineStyle", _
        m_def_OuterFrameBodyLineStyle)

    m_InnerFrameBodyStyle = PropBag.ReadProperty("InnerFrameBodyStyle", _
        m_def_InnerFrameBodyStyle)

    m_InnerFrameBodyLineStyle = PropBag.ReadProperty("InnerFrameBodyLineStyle", _
        m_def_InnerFrameBodyLineStyle)

    m_InnerLineOffset = PropBag.ReadProperty("InnerLineOffset", _
        m_def_InnerLineOffset)

    m_OuterLineOffset = PropBag.ReadProperty("OuterLineOffset", _
        m_def_OuterLineOffset)

End Sub

' Eigenschaftenwerte in den Speicher schreiben
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

    Call PropBag.WriteProperty("BackColor", UserControl.BackColor, &H8000000F)
    Call PropBag.WriteProperty("Font", Font, Ambient.Font)
    Call PropBag.WriteProperty("Caption", CaptionLabel.Caption, "CTDynFrame")
    Call PropBag.WriteProperty("CaptionBarColor", Shape1.FillColor, &H808080)

    Call PropBag.WriteProperty("CaptionActiveColor", m_CaptionActiveColor, _
        m_def_CaptionActiveColor)

    Call PropBag.WriteProperty("CaptionInActiveColor", m_CaptionInActiveColor, _
        m_def_CaptionInActiveColor)

    Call PropBag.WriteProperty("CaptionMouseDownColor", m_CaptionMouseDownColor, _
        m_def_CaptionMouseDownColor)

    Call PropBag.WriteProperty("ShowClose", m_ShowClose, m_def_ShowClose)
    Call PropBag.WriteProperty("ShowHelp", m_ShowHelp, m_def_ShowHelp)
    Call PropBag.WriteProperty("FrameOpen", isOpen)
    Call PropBag.WriteProperty("NormalHeight", normHeight)

    Call PropBag.WriteProperty("CaptionBarStyle", m_CaptionBarStyle, _
        m_def_CaptionBarStyle)

    Call PropBag.WriteProperty("OuterFrameBodyStyle", m_OuterFrameBodyStyle, _
        m_def_OuterFrameBodyStyle)

    Call PropBag.WriteProperty("OuterFrameBodyLineStyle", _
        m_OuterFrameBodyLineStyle, m_def_OuterFrameBodyLineStyle)

    Call PropBag.WriteProperty("InnerFrameBodyStyle", m_InnerFrameBodyStyle, _
        m_def_InnerFrameBodyStyle)

    Call PropBag.WriteProperty("InnerFrameBodyLineStyle", _
        m_InnerFrameBodyLineStyle, m_def_InnerFrameBodyLineStyle)

    Call PropBag.WriteProperty("InnerLineOffset", m_InnerLineOffset, _
        m_def_InnerLineOffset)

    Call PropBag.WriteProperty("OuterLineOffset", m_OuterLineOffset, _
        m_def_OuterLineOffset)

End Sub

Public Property Get InnerFrameBodyStyle() As FrameBodyRect

    InnerFrameBodyStyle = m_InnerFrameBodyStyle

End Property

Public Property Let InnerFrameBodyStyle(ByVal New_InnerFrameBodyStyle As _
    FrameBodyRect)

    m_InnerFrameBodyStyle = New_InnerFrameBodyStyle
    DrawNew
    PropertyChanged "InnerFrameBodyStyle"

End Property

Public Property Get OuterFrameBodyStyle() As FrameBodyRect

    OuterFrameBodyStyle = m_OuterFrameBodyStyle

End Property

Public Property Let OuterFrameBodyStyle(ByVal New_OuterFrameBodyStyle As _
    FrameBodyRect)

    m_OuterFrameBodyStyle = New_OuterFrameBodyStyle
    DrawNew
    PropertyChanged "OuterFrameBodyStyle"

End Property

Public Property Get InnerFrameBodyLineStyle() As FrameBodyLine

    InnerFrameBodyLineStyle = m_InnerFrameBodyLineStyle

End Property

Public Property Let InnerFrameBodyLineStyle(ByVal New_InnerFrameBodyLineStyle As _
    FrameBodyLine)

    m_InnerFrameBodyLineStyle = New_InnerFrameBodyLineStyle
    DrawNew
    PropertyChanged "InnerFrameBodyLineStyle"

End Property

Public Property Get OuterFrameBodyLineStyle() As FrameBodyLine

    OuterFrameBodyLineStyle = m_OuterFrameBodyLineStyle

End Property

Public Property Let OuterFrameBodyLineStyle(ByVal New_OuterFrameBodyLineStyle As _
    FrameBodyLine)

    m_OuterFrameBodyLineStyle = New_OuterFrameBodyLineStyle
    DrawNew
    PropertyChanged "OuterFrameBodyLineStyle"

End Property

Public Property Get OuterLineOffset() As Long

    OuterLineOffset = m_OuterLineOffset

End Property

Public Property Let OuterLineOffset(ByVal New_OuterLineOffset As Long)

    m_OuterLineOffset = New_OuterLineOffset
    DrawNew
    PropertyChanged "OuterLineOffset"

End Property

Public Property Get InnerLineOffset() As Long

    InnerLineOffset = m_InnerLineOffset

End Property

Public Property Let InnerLineOffset(ByVal New_InnerLineOffset As Long)

    m_InnerLineOffset = New_InnerLineOffset
    DrawNew
    PropertyChanged "InnerLineOffset"

End Property



