Attribute VB_Name = "modIStream"
Option Explicit

Public Enum STGTY
    STGTY_STORAGE = &H1
    STGTY_STREAM = &H2
    STGTY_LOCKBYTES = &H3
    STGTY_PROPERTY = &H4
End Enum

Public Enum STGM
    STGM_FAILIFTHERE = &H0
    STGM_DIRECT = &H0
    STGM_READ = &H0
    STGM_WRITE = &H1
    STGM_READWRITE = &H2
    STGM_SHARE_EXCLUSIVE = &H10
    STGM_SHARE_DENY_WRITE = &H20
    STGM_SHARE_DENY_READ = &H30
    STGM_SHARE_DENY_NONE = &H40
    STGM_CREATE = &H1000
    STGM_TRANSACTED = &H10000
    STGM_CONVERT = &H20000
    STGM_PRIORITY = &H40000
    STGM_NOSCRATCH = &H100000
    STGM_NOSNAPSHOT = &H200000
    STGM_DIRECT_SWMR = &H400000
    STGM_SIMPLE = &H8000000
    STGM_DELETEONRELEASE = &H4000000
End Enum

Public Enum STGC
    STGC_DEFAULT = &H0
    STGC_OVERWRITE = &H1
    STGC_ONLYIFCURRENT = &H2
    STGC_DANGEROUSLYCOMMITMERELYTODISKCACHE = &H4
    STGC_CONSOLIDATE = &H8
End Enum

Public Enum STATFLAG
    STATFLAG_DEFAULT = &H0
    STATFLAG_NONAME = &H1
    STATFLAG_NOOPEN = &H2
End Enum

Public Enum STREAM_SEEK
    STREAM_SEEK_SET = &H0
    STREAM_SEEK_CUR = &H1
    STREAM_SEEK_END = &H2
End Enum

Public Enum LOCKTYPE
    LOCK_WRITE = &H1
    LOCK_EXCLUSIVE = &H2
    LOCK_ONLYONCE = &H4
End Enum

Public Type STATSTG
    atime As Currency
    cbSize As Currency
    clsid As GUID
    ctime As Currency
    grfLocksSupported As LOCKTYPE
    grfMode As STGM
    grfStateBits As Long
    mtime As Currency
    pwcsName As Long
    reserved As Long
    Type As STGTY
End Type
